//
//  exercise2.cpp
//  Session 8
//
//  Created by Luis Angel on 5/21/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>

using namespace std;

struct Card
{
	const char *suit;	// A pointer to a constant char (C string).
	int face;			// A number between 1 and 13.
};

const int TOTAL_CARDS = 52;
const int CARDS_PER_SUIT = 13;
const int N_SUITS = 4;

void initDeck( Card *ptr, const char s[][9] )
{
	for( int I = 0; I < TOTAL_CARDS; I++ )
	{
		ptr[I].face = I % CARDS_PER_SUIT + 1;
		ptr[I].suit = s[I/CARDS_PER_SUIT];
	}
}

void shuffle( Card *ptr )
{
	for( int I = 0; I < TOTAL_CARDS; I++ )	// Move each chard from its original location.
	{
		int J = rand() % TOTAL_CARDS;		// New random location.
		Card temp = ptr[I];
		ptr[I] = ptr[J];					// Swap.
		ptr[J] = temp;
	}
}

int main2()
{
	Card deck[TOTAL_CARDS];
	const char suit[N_SUITS][9] = { "Hearts", "Diamonds", "Spades", "Clubs" };
	
	initDeck( deck, suit );
	shuffle( deck );
	
	for( int I = 0; I < TOTAL_CARDS; I++ )
		cout << deck[I].face << " of " << deck[I].suit << endl;
	
	return 0;
}
